0 REM SCITRONICS-TIME.BAS.txt  SCITIME.BAS

2 ' 
3 ' SciTronics RTC setting and reading program
4 ' Duplicated from the SciTronics manual
5 ' Validated to operate 9 Jan 2024
6 '
10 DEFINT A-Z
20 DIM TIME(13) ,W$(7) ,MO$(12)
30 P0=208 'CLOCK PORT 0D0H change to your port address
40 P1=P0+1
50 P2=P0+2
60 P3=P0+3  
70 W$(0)="Sunday "
80 W$(1)="Monday "
90 W$(2)="Tuesday "
100 W$(3)="Wednesday "
110 W$(4)="Thursday "
120 W$(5)="Friday "
130 W$(6)="Saturday "
140 '
150 MO$(1)=" January "
160 MO$(2)=" February "
170 MO$(3)=" March "
180 MO$(4)=" April "
190 MO$(5)=" May "
200 MO$(6)=" June "
210 MO$(7)=" July "
220 MO$(8)=" August "
230 MO$(9)=" September "
240 MO$(10)=" October "
250 MO$(11)=" November "
260 MO$(12)=" December "
270 '
280 PRINT CHR$(26) 'clears screen on TeleVideo 912/920 terminal
290 PRINT
300 PRINT "Enter <T> for time display ONLY"
310 PRINT "Enter <S> for time setting"
320 PRINT "Enter <E> for EXIT"
330 X1$=INKEY$
340 IF X1$< CHR$(32) THEN 330
350 IF X1$="T" THEN 1000
360 IF X1$="t" THEN 1000
370 IF X1$="E" THEN END
380 IF X1$="e" THEN END
390 IF X1$="S" THEN 420
400 IF X1$="s" THEN 420
410 GOTO 330


420 PRINT CHR$(26)
430 PRINT
440 PRINT "Enter DATE in the form:"
450 PRINT" YY,MM,DD"
460 INPUT YR,MO,DA
470 PRINT
480 PRINT "Enter DAY-OF-THE-WEEK"
490 PRINT
500 PRINT " 0 = Sunday"
510 PRINT " 1 = Monday"
520 PRINT " 2 = Tuesday"
530 PRINT " 3 = Wednesday"
540 PRINT " 4 = Thursday"
550 PRINT " 5 = Friday"
560 PRINT " 6 = Saturday"
570 PRINT
580 INPUT W
590 PRINT
600 PRINT "Enter TIME on 24HR clock in the form of:"
610 PRINT " HH,MM"
620 INPUT HR, MIN
630 'PREPARE THE DATA FOR ENTRY
640 TIME (1) =16*INT(YR/10)+12
650 TIME (2) =16*(YR-10*INT(YR/10))+11
660 TIME (3) =16*INT(MO/10)+10
670 TIME (4) =16*(MO-10*INT(MO/10) )+9
680 TIME (5) =16*INT(DA/10)+8
690 TIME (6) =16*(DA-10*INT(DA/10))+7
700 TIME (7) =16*W+6
710 TIME (8) =16*INT(HR/10)+5+128
720 TIME (9) =16*(HR-10*INT(HR/10))+4
730 TIME(10) =16*INT(MIN/10)+3
740 TIME(11) =16*(MIN-10*INT(MIN/10))+2
750 TIME(12) =1
760 TIME(13) =0
770 'DATA IS READY, ASK FOR
780 'START SIGNAL FROM USER
790 PRINT
800 PRINT "Press any key to set and start clock with zero seconds"
810 X$=INKEY$
820 IF X$< CHR$ (32) THEN 810
830 IF LEN(X$)=0 THEN 810


840 ' THIS IS THE SETTING SEQUENCE
850 OUT P3,244
860 OUT P2,255
870 OUT P3,240
880 OUT P2,255
890 OUT P1,240
900 OUT P0,255
910 OUT P3,244
920 OUT P1,244
930 FOR X=1 TO 13
940   OUT P0,TIME(X)
950   OUT P2,0
960   OUT P2,1
970 NEXT X
980 OUT P1,248
990 OUT P3,240
1000  ' READ CLOCK
1010 PRINT CHR$(26)
1020  '
1030  ' THIS READS THE CLOCK DATA
1040  '
1050 OUT P1,240
1060 OUT P0, 15
1070 OUT P1,244
1080 OUT P3,252
1090 FOR X=1 TO 13
1100   OUT P0,13-X
1110   TIME(X)=INP(P0)
1120 NEXT X
1130  ' PUT CLOCK BACK INTO RUNNING MODE
1140 OUT P3, 240
1150 OUT P1, 248
1160 FOR X=1 TO 13
1170   TIME(X)=INT(TIME(X)/16)
1180 NEXT X
1190 ' THERE ARE SPECIAL MARKS ON HOURS AND MONTH
1200 ' STRIP THEM OFF
1210 TIME(3) = TIME(3) AND 3
1220 TIME(8) = TIME(8) AND 3
1230 '

1240 Y$= CHR$(TIME (1)+48)+CHR$(TIME (2)+48)
1250 MO= TIME(3)*10+TIME(4)
1260 IF TIME(5)>0 THEN D$=CHR$(TIME(5)+48)+CHR$(TIME(6)+48) :GOTO 1280
1270 D$= CHR$(TIME (6)+48)
1280 W= TIME (7)
1290 H$= CHR$(TIME (8)+48)+CHR$(TIME (9)+48)
1300 MI$= CHR$(TIME(10)+48)+CHR$(TIME(11)+48)
1310 S$= CHR$(TIME(12)+48)+CHR$(TIME(13)+48)
1320 '
1325 ' below commented out as it prevents the time from displaying in MSBASIC on my IMSAI
1330 ' X$=INKEY$
1340 'IF X$< CHR$(32) THEN 1330
1350 'IF LEN(X$)<>0 THEN 280
1360 'IF S1$=S$ THEN 1050 ELSE S1$=S$
1370 '
1380 PRINT CHR$(30);'Cursor home command
1390 PRINT "                    ";
1400 PRINT W$(W);
1410 PRINT H$;":";MI$;":";S$;
1420 PRINT MO$(MO);D$;" ";"19";Y$
1430 PRINT CHR$(30);
1440 GOTO 1050
